=== debian/control ===
Source: libstlink
Priority: optional
Maintainer: Andrew 'Necromant' Andrianov <andrew@ncrmnt.org>
Build-Depends: debhelper (>= 9), cmake, libusb-1.0-0-dev, libgtk-3-dev
Standards-Version: 3.9.5
Section: libs
Homepage: https://github.com/texane/stlink
Vcs-Git: https://github.com/texane/stlink.git
Vcs-Browser: https://github.com/texane/stlink

Package: libstlink-dev
Section: libdevel
Architecture: any
Depends: libstlink (= ${binary:Version}), ${misc:Depends}
Description: OpenSource ST-Link tools replacement. Development headers.
    This package contains development headers for libstlink.

Package: libstlink
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenSource ST-Link tools replacement. Shared library.
    This package libstlink shared library.

Package: stlink-tools
Section: libdevel
Architecture: any
Depends: libstlink (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: OpenSource ST-Link tools replacement. Commandline Utilities.

Package: stlink-gui
Section: libdevel
Architecture: any
Depends: libstlink (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: OpenSource ST-Link tools replacement. GUI Tool.
